/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AndroidFileSystem.java,v 3e7ea5dbefcb 2010/05/17 15:10:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.android;

import javax.annotation.Nonnull;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import org.openide.util.lookup.ServiceProvider;
import org.openide.util.Lookup;
import android.content.Context;
import it.tidalwave.mobile.FileSystem;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
@ServiceProvider(service=FileSystem.class)
public class AndroidFileSystem implements FileSystem
  {
    @Nonnull
    private final Context context = Lookup.getDefault().lookup(Context.class);

    @Nonnull
    public FileOutputStream openFileOutput (final @Nonnull String name)
      throws IOException
      {
        return context.openFileOutput(name, Context.MODE_PRIVATE);
      }

    @Nonnull
    public FileInputStream openFileInput (final @Nonnull String name)
      throws IOException
      {
        return context.openFileInput(name);
      }
  }
