/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DisplayableArrayAdapter.java,v 65fe56c7e42d 2010/05/28 21:45:35 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.android;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.util.Displayable;
import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class DisplayableArrayAdapter<T extends Displayable> extends ArrayAdapter<T>
  {

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int resource,
                                    final int textViewResourceId,
                                    final @Nonnull List<T> objects)
      {
        super(context, resource, textViewResourceId, objects);
      }

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int textViewResourceId,
                                    final @Nonnull List<T> objects)
      {
        super(context, textViewResourceId, objects);
      }

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int resource,
                                    final int textViewResourceId,
                                    final @Nonnull T[] objects)
      {
        super(context, resource, textViewResourceId, objects);
      }

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int textViewResourceId,
                                    final @Nonnull T[] objects)
      {
        super(context, textViewResourceId, objects);
      }

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int resource,
                                    final int textViewResourceId)
      {
        super(context, resource, textViewResourceId);
      }

    public DisplayableArrayAdapter (final @Nonnull Context context,
                                    final int textViewResourceId)
      {
        super(context, textViewResourceId);
      }

    @Override @Nonnull
    public View getView (final @Nonnegative int position,
                         final @Nonnull View convertView,
                         final @Nonnull ViewGroup parent)
      {
        return fixedView(position, super.getView(position, convertView, parent));
      }

    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent)
      {
        return fixedView(position, super.getDropDownView(position, convertView, parent));
      }

//    @Override TODO
//    public void sort(Comparator<? super T> comparator)
//      {
//        super.sort(comparator);
//      }

    @Nonnull
    private View fixedView (final @Nonnegative int position,
                            final @Nonnull View view)
      {
        if (view instanceof TextView)
          {
            ((TextView)view).setText(getItem(position).getDisplayName());
          }

        return view;
      }
  }
